
#ifndef file_mainframe
#define file_mainframe

#include <vector>

class Document;
class View;

class MainFrame : public CL_Frame
{
//! Construction:
public:
	MainFrame(CL_Component *parent, CL_ResourceManager *resources);

	~MainFrame();

//! Attributes:
public:
	Document *get_document();

	int get_num_views();

	View *get_view(int index);

	View *get_active_view();

	CL_Rect get_view_area();

	CL_ResourceManager *get_resources();

//! Operations:
public:
	void set_active_view(View *view);

	void set_active_view(int index);

	void add_view(View *view);

	void remove_view(View *view);

	int find_view_index(View *view);

//! Implementation:
private:
	void on_paint();

	CL_ResourceManager *resources;

	Document *document;

	std::vector<View *> views;

	int active_view;

	CL_SlotContainer slots;
};

#endif
