/*
        CL_Canvas test app.
*/

#include <ClanLib/core.h>
#include <ClanLib/application.h>
#include <ClanLib/display.h>
#include <ClanLib/gl.h>

class DrawingApp : public CL_ClanApplication
{
public:
	virtual int main(int, char **)
	{
		// Create a console window for text-output if not available
		CL_ConsoleWindow console("Console");
		console.redirect_stdio();

		try
		{
			std::cout << "Example status: Not working!" << std::endl;

			CL_SetupCore::init();
			CL_SetupDisplay::init();
			CL_SetupGL::init();

			CL_DisplayWindow window("Drawing application", 320, 200);

			CL_Canvas *src_canvas = new CL_Canvas(CL_Size(320, 200)); // transcol == black

	//		src_canvas->fill_rect(0, 0, 319, 199, 1.0, 1.0, 1.0, 1.0);
	//		src_canvas->fill_rect(160, 0, 319, 199, 0.0, 0.0, 0.0, 1.0);

			CL_Canvas *dst_canvas = new CL_Canvas(CL_Size(320,200));

			dst_canvas->get_pixelbuffer().get_gc()->fill_rect(CL_Rect(0, 0, 319, 199), CL_Color(0, 0, 255, 255));

			//CL_Surface *src_surface = CL_Surface::create(src_canvas);
//			src_surface->put_target(0,0,0, dst_canvas);

			//CL_Surface *dst_surface = CL_Surface::create(dst_canvas);

			// Loop until the user hits escape:
			while (1)
			{
				// put the destination surface on the screen please
				dst_canvas->draw(0,0);

				// Flip front and backbuffer. This makes any changes visible:
				CL_Display::flip();

				// Update keyboard input and handle system events:
				// Exits the loop if ClanLib requests shutdown - for instance if
				// someone closes the window.
				CL_System::keep_alive();

				// Sleep alittle to free up some CPU cycles
				CL_System::sleep(10);
			}

			delete src_canvas;
			delete dst_canvas;
	//		delete src_surface;
	//		delete dst_surface;

			CL_SetupDisplay::deinit();
			CL_SetupCore::deinit();
		}
		catch (CL_Error err)
		{
			std::cout << "Exception caught: " << err.message.c_str() << std::endl;

			// Display console close message and wait for a key
			console.display_close_message();

			return -1;
		}

		return 0;
	}
} app;
