/*
	Font Example
*/

#include <ClanLib/core.h>
#include <ClanLib/application.h>
#include <ClanLib/display.h>
#include <ClanLib/gl.h>

class FontApp : public CL_ClanApplication
{
public:
	int main(int, char **)
	{
		try
		{
			CL_SetupCore::init();
			CL_SetupDisplay::init();
			CL_SetupGL::init();
			
			CL_ResourceManager resources("font.scr", false);
            
			CL_DisplayWindow window("ClanLib Font Example", 640, 480);
			
			//Load the font from the resource "Font" in the resources file
			CL_Font font("Font", &resources);
			
			while(!CL_Keyboard::get_keycode(CL_KEY_ESCAPE))
			{
				CL_Display::clear(CL_Color::white);
				
				//Draw the text with its upper-left corner at 25, 25
				font.draw(25, 25, "ClanLib: Phear the Power!");
				
				CL_Display::flip();
				CL_System::keep_alive(15);
			}
			
			CL_SetupGL::deinit();
			CL_SetupDisplay::deinit();
			CL_SetupCore::deinit();
		}
		catch (CL_Error err)
		{
			std::cout << "Exception caught: " << err.message.c_str() << std::endl;
			return -1;
		}
		
		return 0;
	}
} app;
