
#ifndef header_world
#define header_world

#include "gameobject.h"
#include "gameobject_pacman.h"
#include "map.h"

class World
{
//!Construction:
public:
	World(CL_ResourceManager *resources);

	~World();

//!Attributes:
public:
	CL_ResourceManager *resources;
	
	Map *map;

	std::list<GameObject*> objects;

	GameObject_Pacman *player;

	int score;
	
	bool quit;

//!Operations:
public:
	void run(CL_DisplayWindow &window);

//!Implementation:
private:
	void on_key_down(const CL_InputEvent &key);
	int calc_fps(float frame_time);

	int view_x, view_y;

	CL_Font fnt_clansoft;
};

#endif
