
#include "server_world.h"

/////////////////////////////////////////////////////////////////////////////
// ServerWorld construction:

ServerWorld::ServerWorld(CL_NetSession &session)
: session(session), voice_controller(&session, "voice_netobjs")
{
	slots.connect(session.sig_computer_connected(), this, &ServerWorld::on_computer_connected);
	slots.connect(session.sig_computer_disconnected(), this, &ServerWorld::on_computer_disconnected);
	slots.connect(voice_controller.sig_create_object(), this, &ServerWorld::on_voice_create);
}

ServerWorld::~ServerWorld()
{
}

/////////////////////////////////////////////////////////////////////////////
// ServerWorld attributes:


/////////////////////////////////////////////////////////////////////////////
// ServerWorld operations:


/////////////////////////////////////////////////////////////////////////////
// ServerWorld implementation:

void ServerWorld::on_computer_connected(CL_NetComputer &netcomputer)
{
}

void ServerWorld::on_computer_disconnected(CL_NetComputer &netcomputer)
{
	std::map<std::string, CL_VoiceServer>::iterator it;
	for (it = channels.begin(); it != channels.end(); it++)
	{
		it->second->disconnect(netcomputer);
	}
}

void ServerWorld::on_voice_create(
	CL_NetObject_Client &netobj_handle,
	int msg_type,
	CL_NetPacket &message)
{
	if (msg_type != 0) return;

	std::string channel_name = message.input.read_string();
	channels[channel_name].connect(netobj_handle);
}
