/*
	$Id: clanapp.h,v 1.14 2002/11/15 10:40:07 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanApp="System"

#ifndef header_clanapp
#define header_clanapp

//: The starting place for all applications.
//- <p> The application class must be inherited by all ClanLib applications.
//- In your application create a class inheriting CL_ClanApplication, 
//- make a global instance of it, and fill in the main() function. </p>
class CL_ClanApplication
{
public:
	//: Clan Application constructor
	CL_ClanApplication();

	//: Clan Application destructor
	virtual ~CL_ClanApplication();

	//: Main application function
	//- <p> Every program made using ClanLib must implement this function. 
	//- This is the main application function, which will be called 
	//- <i>once</i> following system initialization. </p>
	//param argc: The number of arguments to the program (c-style)
	//param argv: A pointer to strings, containing the program arguments. The name of the program executable is always passed as first argument.
	//return: Program return value
	virtual int main(int argc, char** argv)=0;

	//: Static pointer to an initialized instance of this class.
	//: This is set by the constructor.
	static CL_ClanApplication *app;
};

#endif
