/*
	$Id: directory.h,v 1.2 2003/02/23 12:06:04 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanCore="I/O Data"
//! header=core.h

#ifndef header_directory
#define header_directory

#include <string>

//: Directory utility class
class CL_Directory
{
//! Operations:
public:
	//: Create directory.
	//- <p>return true on success or false on error.</p>
	//param dir_name: Directory name for create.
	static bool create(std::string const & dir_name);

	//: Remove directory.
	//- <p>Return true on success or false on error.</p>
	//param dir_name: Directory name for delete.
	//param delete_files: If true, function will delete files.
	//param delete_sub_directoies: If true, function will delete
	//param delete_sub_directoies: sub directoies too.
	static bool remove(
		std::string const & dir_name,
		bool delete_files = false,
		bool delete_sub_directories = false);
};

#endif // header_directory
