/*
	$Id: origin.h,v 1.2 2003/02/10 22:25:54 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanDisplay="Display 2D"
//! header=display.h

#ifndef header_origin
#define header_origin

#include "size.h"
#include "point.h"

//: Alignment origins.
enum CL_Origin
{
	origin_top_left,
	origin_top_center,
	origin_top_right,
	origin_center_left,
	origin_center,
	origin_center_right,
	origin_bottom_left,
	origin_bottom_center,
	origin_bottom_right,
};

//: Returns the anchor point for the origin within the dimensions of the size structure.
CL_Point calc_origin(CL_Origin origin, const CL_Size &size);
CL_Pointf calc_origin(CL_Origin origin, const CL_Sizef &size);

#endif
