/*
	$Id: dc_buffer.h,v 1.5 2002/07/15 16:49:49 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanDisplay="Surface Providers"
//! header=display.h

#ifndef header_dc_buffer
#define header_dc_buffer

#ifdef WIN32
#include <windows.h>

#include "../pixel_buffer.h"

//: Win32 Device Context pixelbuffer.
//- <p>This is class is not crossplatform. It allows win32 applications to paint
//- to a pixelbuffer using device context system calls.</p>
class CL_DeviceContextBuffer : public CL_PixelBuffer
{
//! Construction:
public:
	//: Construct a pixelbuffer using the pixel format of the passed device context.
	CL_DeviceContextBuffer(HDC reference_dc, int width, int height);

//! Attributes:
public:
	//: Returns device context of pixelbuffer.
	HDC get_dc();

//! Implementation:
private:
};

#endif

#endif
