/*
	$Id: jpeg_provider.h,v 1.6 2002/07/15 16:49:49 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanDisplay="Surface Providers"
//! header=display.h

#ifndef header_jpeg_provider
#define header_jpeg_provider

#include "../pixel_buffer.h"
#include <string>

class CL_InputSourceProvider;

//: Surface provider that can load JPEG (.jpg) files.
class CL_JPEGProvider : public CL_PixelBuffer
{
//! Construction:
public:
	//: Constructs a surface provider that can read JPEG files.
	//param name: Name of the JPEG file to load.
	//param provider: Input source provider that delivers the JPEG file.
	//param transparent: True if a transparency color should be used.
	//param ignore_alphachannel: True if the alpha component should be ignored.
	CL_JPEGProvider(
		const std::string &name, 
		CL_InputSourceProvider *provider = 0,
		bool transparent = true,
		bool ignore_alphachannel = false);
};

#endif
