/*
	$Id: inputdialog.h,v 1.3 2003/02/25 21:08:37 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_inputdialog
#define header_inputdialog

#include "window.h"

class CL_InputDialog_Generic;

//: CL_InputDialog component
class CL_InputDialog : public CL_Window
{
//! Construction:
public:
	//: CL_InputDialog constructor
	CL_InputDialog(
		const std::string &title,
		const std::string &button1,
		const std::string &button2,
		const std::string &button3,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	
	//: CL_InputDialog destructor
	virtual ~CL_InputDialog();

//! Operations:
public:
	//: Add inputbox with laber to dialog.
	CL_InputBox *add_input_box(const std::string &label = "",
		const std::string &default_value = "", int inputbox_width = 100);

//! Implementation:
private:
	CL_InputDialog(const CL_InputDialog &copy) : CL_Window(NULL, NULL) { return; } // disallow copy construction.

	CL_InputDialog_Generic *impl;
};

#endif
