/*
	$Id: messagebox.h,v 1.24 2003/02/25 21:08:37 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_messagebox
#define header_messagebox

#include "window.h"

class CL_MessageBox_Generic;

//: MessageBox component
class CL_MessageBox : public CL_Window
{
//! Construction:
public:
	//: Creates a messagebox.
	//: Returns the button clicked, starting at index 0.
	static int info(
		const std::string &text,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	static int info(
		const std::string &title,
		const std::string &text,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	static int info(
		const std::string &title,
		const std::string &text,
		const std::string &button1,
		const std::string &button2,
		const std::string &button3,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

//! Attributes:
public:
	//: Returns the index of the button clicked.
	int get_result_button() const;

//! Implementation:
private:
	CL_MessageBox(const CL_MessageBox &copy) : CL_Window(NULL, NULL) { return; } // disallow copy construction.

	//: MessageBox constructor
	CL_MessageBox(
		const std::string &title,
		const std::string &text,
		const std::string &button1,
		const std::string &button2,
		const std::string &button3,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	//: MessageBox destructor
	virtual ~CL_MessageBox();

	CL_MessageBox_Generic *impl;
};

#endif
