/*
	$Id: popupmenu.h,v 1.33 2002/12/05 00:01:25 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_popupmenu
#define header_popupmenu

#include "component.h"
#include "menudata.h"

class CL_PopupMenu_Generic;

//: PopupMenu component
class CL_PopupMenu : public CL_Component, public CL_MenuData
{
//! Construction:
public:
	//: PopupMenu Constructor
	CL_PopupMenu(
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	
	//: PopupMenu Constructor
	CL_PopupMenu(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	//: PopupMenu Destructor
	virtual ~CL_PopupMenu();

//! Attributes:
public:

//! Operations:
public:
	//: Popup the popupmenu.
	void popup(CL_Component *parent);
	
//! Signals:
public:
	//: This signal is emitted when the selection set of a tree changes.
	CL_Signal_v1<const CL_MenuNode &> &sig_selection_changed();

	//: This signal is emitted when the popupmenu is cancelled.
	CL_Signal_v0 &sig_cancelled();

//! Implementation:
private:
	CL_PopupMenu(const CL_PopupMenu &copy) : CL_Component(NULL, NULL), CL_MenuData(NULL) { return; } // disallow copy construction.
	CL_PopupMenu_Generic *impl;
};

#endif
