/*
	$Id: window.h,v 1.30 2003/02/15 12:07:22 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_window
#define header_window

#include "component.h"

class CL_Window_Generic;

//: Window component
//- <p>Script attributes:</p>
//- <ul>
//- <li>title: The text of the button. Same as CL_Button::set_text(). [String]</li>
//- </ul>
//- <p>Note that it inherits the attributes of a CL_Component as well.</p>
class CL_Window : public CL_Component
{
//! Construction:
public:
	//: Creates a window.
	CL_Window(
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	CL_Window(
		const std::string &title,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	CL_Window(
		const CL_Rect &pos,
		const std::string &title,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	CL_Window(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	//: Window destructor
	virtual ~CL_Window();

//! Attributes:
public:
	//: Returns the window title.
	const std::string &get_title() const;

//! Operations:
public:
	//: Sets the window title.
	//param text: An std::string with the new title
	void set_title(const std::string &text);

//! Signals:
public:

//! Implementation:
private:
	CL_Window(const CL_Window &copy) : CL_Component(NULL, NULL) { return; } // disallow copy construction.
	CL_Window_Generic *impl;
};  

#endif
