//! clanJavaScript="Framework"
//! header=javascript.h

#ifndef header_js_classfactory
#define header_js_classfactory

#include "js_object.h"
#include "js_value.h"
#include "js_error.h"

template<class Object>
class CL_JSClassFactory : public CL_JSObject
{
public:
	CL_JSClassFactory(const char *name, int argc, CL_JSContext &context, CL_JSObject &obj)
	: CL_JSObject(name)
	{
		jsClass.construct = factoryConstruct;
		initClass(context, obj.getObject(), 0, 0, argc, 0, 0, 0, 0);
	}

	virtual CL_JSValue onConstruct(CL_JSContext *context, CL_JSArguments &args)
	{
		return CL_JSValue(context, new Object(context, args));
	}
	
	static JSBool factoryConstruct(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
	{
		JScriptContext *context = JScriptContext::tempFromHandle(cx);
		JScriptArguments args(context, argc, argv);
		
		try
		{
			*rval = JScriptValue(context, new Object(context, args));
			return JS_TRUE;
		}
		catch (JScriptError &)
		{
			// todo: Somehow pipe error message into javascript engine.
			return JS_FALSE;
		}
	}
};

#endif
