/*
	$Id: voice_client.h,v 1.7 2002/07/15 16:49:51 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanVoice="Network"
//! header=ttf.h

#ifndef header_voice_client
#define header_voice_client

class CL_NetObject_Server;
class CL_VoiceClient_Generic;

//: Voice client
class CL_VoiceClient
{
//! Construction:
public:
	//: Construct voice client.
	CL_VoiceClient(CL_NetObject_Controller *controller);

	//: Destroy voice client.
	~CL_VoiceClient();

//! Attributes:
public:

//! Operations:
public:
	//: Connect to voice server.
	void connect(CL_NetComputer &server, CL_NetPacket &connect_data);

	//: Disconnect from voice server.
	void disconnect(CL_NetComputer &server);

	//: Start local recording and upload to server.
	void start_recording();

	//: Stop local recording and upload to server.
	void stop_recording();

//! Implementation:
private:
	CL_VoiceClient_Generic *impl;
};

#endif


/*

#define msg_connect   0
#define msg_voicedata 1

	VoiceClient(CL_NetObject_Controller *controller)
	: handle(controller)
	{
		slots.connect(handle.sig_received_message(msg_voicedata), this, &VoiceClient::on_voice_from_server);
	}

	void connect_server(CL_NetComputer server, CL_NetPacket &connectdata)
	{
		servers.push_back(server);
		handle.send(server, msg_connect, connectdata);
	}

	void voice_from_mic(CL_NetPacket &voicedata)
	{
		std::list<CL_NetComputer>::iterator it;
		for (it = servers.begin(); it != servers.end(); it++)
		{
			handle.send(server_computer, msg_voicedata, voicedata);
		}
	}

	void on_voice_from_server(const CL_NetComputer &computer CL_NetPacket &voicedata)
	{
		play_on_soundcard(voicedata);
	}

	CL_NetObject_Server handle;
	std::list<CL_NetComputer> servers;
	CL_SlotContainer slots;

*/
