/*
	$Id: voice_encoder.h,v 1.5 2002/07/15 16:49:51 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanVoice="Encoding"
//! header=ttf.h

#ifndef header_voice_encoder
#define header_voice_encoder

#include "voice_codec.h"
#include <string>

class CL_StreamSoundProvider_Session;
class CL_VoiceEncoder_Generic;

//: Voice Encoder
class CL_VoiceEncoder
{
//! Construction:
public:
	//: Construct voice encoder.
	CL_VoiceEncoder(
		CL_StreamSoundProvider_Session *source,
		CL_VoiceCodec codec = cl_codec_gsm);

	~CL_VoiceEncoder();

//! Operations:
public:
	//: Encodes a packet of audio data. Returns empty string if not enough
	//: audio data is available yet to produce packet.
	std::string encode_packet();

//! Implementation:
private:
	CL_VoiceEncoder_Generic *impl;
};

#endif
