/*
	$Id: voice_server.h,v 1.6 2002/07/15 16:49:51 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanVoice="Network"
//! header=ttf.h

#ifndef header_voice_server
#define header_voice_server

class CL_NetObject_Client;
class CL_VoiceServer_Generic;

//: Voice Server
class CL_VoiceServer
{
//! Construction:
public:
	//: Construct a voice server.
	CL_VoiceServer();

	//: Destroy voice server.
	~CL_VoiceServer();

//! Attributes:
public:

//! Operations:
public:
	//: Connect voice client.
	void connect(CL_NetObject_Client &client);

	//: Disconnect voice client.
	void disconnect(CL_NetObject_Client &client);

	//: Disconnect voice clients from computer.
	void disconnect(CL_NetComputer &client);

	//: Mute all voice from client 'source' destinated to client 'dest'.
	void mute(CL_NetObject_Client &source, CL_NetObject_Client &dest);

	//: Mute all voice from netcomputer 'source' destinated to netcomputer 'dest'.
	void mute(CL_NetComputer &source, CL_NetComputer &dest);

	//: Unmute all voice from client 'source' destinated to client 'dest'.
	void unmute(CL_NetObject_Client &source, CL_NetObject_Client &dest);

	//: Unmute all voice from netcomputer 'source' destinated to netcomputer 'dest'.
	void unmute(CL_NetComputer &source, CL_NetComputer &dest);

//! Implementation:
private:
	CL_VoiceServer_Generic *impl;
};

#endif


/*
class VoiceServer
{
public:
	// Connect client to server.
	void connect_client(CL_NetObject_Client &client)
	{
		clients.push_back(client);
		slots.connect(client.sig_received_message(msg_voicedata), this, &VoiceServer::on_voice_received);
	}

private:
	// Called when server received voicedata from a client.
	void on_voice_received(CL_NetPacket &voicedata)
	{
		std::list<CL_NetObject_Client>::iterator it;
		for (it = clients.begin(); it != clients.end(); it++)
		{
			it->send(msg_voicedata, voicedata);
		}
	}

	std::list<CL_NetObject_Client> clients;
	CL_SlotContainer slots;
};
*/
