/*
	$Id: network.h,v 1.11 2002/06/09 00:28:02 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//: <p>Enables network communication.  Includes low-lever socket access as well
//: as higher-level network objects.</p>
//! Global=Network


#ifndef header_network_api
#define header_network_api

#ifdef WIN32
#pragma warning( disable : 4786)
#endif

#include "Network/IRC/irc_connection.h"
#include "Network/IRC/irc_numerics.h"

#include "Network/Browse/browse_client.h"
#include "Network/Browse/browse_server.h"
#include "Network/Browse/browse_master.h"

#include "Network/NetVariables/netvariables.h"

#include "Network/NetObjects/netobject_client.h"
#include "Network/NetObjects/netobject_controller.h"
#include "Network/NetObjects/netobject_server.h"

#include "Network/NetSession/inputsource_netpacket.h"
#include "Network/NetSession/inputsource_netstream.h"
#include "Network/NetSession/netcomputer.h"
#include "Network/NetSession/netgroup.h"
#include "Network/NetSession/netpacket.h"
#include "Network/NetSession/netsession.h"
#include "Network/NetSession/netstream.h"
#include "Network/NetSession/outputsource_netpacket.h"
#include "Network/NetSession/outputsource_netstream.h"

#include "Network/Socket/inputsource_socket.h"
#include "Network/Socket/ip_address.h"
#include "Network/Socket/outputsource_socket.h"
#include "Network/Socket/socket.h"

#include "Network/setupnetwork.h"

#if defined (_MSC_VER)
#if !defined (_DEBUG)
#pragma comment(lib, "clanNetwork.lib")
#else
#pragma comment(lib, "clanNetworkd.lib")
#endif
#endif

#endif
