/*
	$Id: origin.cpp,v 1.3 2003/02/10 22:25:54 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include "Core/precomp.h"

#include "API/Core/Math/origin.h"

CL_Point calc_origin(CL_Origin origin, const CL_Size &size)
{
	switch(origin)
	{
	case origin_top_left:
	default:
		return CL_Point(0, 0);
		break;
	case origin_top_center:
		return CL_Point(size.width / 2, 0);
		break;
	case origin_top_right:
		return CL_Point(size.width, 0);
		break;
	case origin_center_left:
		return CL_Point(0, size.height / 2);
		break;
	case origin_center:
		return CL_Point(size.width / 2, size.height / 2);
		break;
	case origin_center_right:
		return CL_Point(size.width, size.height / 2);
		break;
	case origin_bottom_left:
		return CL_Point(0, size.height);
		break;
	case origin_bottom_center:
		return CL_Point(size.width / 2, size.height);
		break;
	case origin_bottom_right:
		return CL_Point(size.width, size.height);
		break;
	}
}

CL_Pointf calc_origin(CL_Origin origin, const CL_Sizef &size)
{
	switch(origin)
	{
	case origin_top_left:
	default:
		return CL_Pointf(0, 0);
		break;
	case origin_top_center:
		return CL_Pointf(size.width / 2, 0);
		break;
	case origin_top_right:
		return CL_Pointf(size.width, 0);
		break;
	case origin_center_left:
		return CL_Pointf(0, size.height / 2);
		break;
	case origin_center:
		return CL_Pointf(size.width / 2, size.height / 2);
		break;
	case origin_center_right:
		return CL_Pointf(size.width, size.height / 2);
		break;
	case origin_bottom_left:
		return CL_Pointf(0, size.height);
		break;
	case origin_bottom_center:
		return CL_Pointf(size.width / 2, size.height);
		break;
	case origin_bottom_right:
		return CL_Pointf(size.width, size.height);
		break;
	}
}
