

#include "Core/precomp.h"
#include "clanstring_generic.h"    

#include <stdio.h>

/////////////////////////////////////////////////////////////////////////////
// CL_String_Generic construction:

CL_String_Generic::CL_String_Generic() : next_arg(1)
{
}
	
CL_String_Generic::~CL_String_Generic()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_String_Generic attributes:

/////////////////////////////////////////////////////////////////////////////
// CL_String_Generic operations:

void CL_String_Generic::replace_arg(const std::string &str)
{
	char buffer[32];
	buffer[0] = '%';
	sprintf(buffer+1, "%d", next_arg++);

	int pos = data.find(buffer);
	if (pos == data.npos) return; // %n not found.

	data = data.substr(0, pos) + str + data.substr(pos + strlen(buffer));
}

void CL_String_Generic::copy(CL_String_Generic *other)
{
	data = other->data;
	next_arg = other->next_arg;
}

std::vector<std::string> CL_String_Generic::tokenize(const std::string &str_delimit) const
{
	std::vector<std::string> ret;
	std::string delimit = str_delimit;

	std::string::size_type last_pos = data.find_first_not_of(delimit, 0);
	std::string::size_type pos = data.find_first_of(delimit, last_pos);
	while (std::string::npos != pos || std::string::npos != last_pos)
	{
		ret.push_back(data.substr(last_pos, pos - last_pos));
		last_pos = data.find_first_not_of(delimit, pos);
		pos = data.find_first_of(delimit, last_pos);
	}

	return ret;
}

/////////////////////////////////////////////////////////////////////////////
// CL_String_Generic implementation:
