/*
	$Id: event_trigger_generic.h,v 1.8 2002/07/17 14:55:29 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_event_trigger_generic
#define header_event_trigger_generic

class CL_EventListener;

class CL_EventTrigger_Generic
{
//! Construction:
public:
	CL_EventTrigger_Generic();

	virtual ~CL_EventTrigger_Generic();

//! Attributes:
public:
	virtual bool get_flag() const=0;

//! Operations:
public:
	//: Reset trigger flag.
	virtual void reset() const=0;

	//: Raise trigger flag.
	virtual void set_flag()=0;

	//: Wait until one of the event triggers. The timeout is in milliseconds.
	//return: true if the event triggered, false if it timed out.
	virtual bool wait(int timeout = -1) const=0;

	//: Increase reference count.
	void add_ref();

	//: Decrease reference count.
	void release_ref();

//! Implementation:
private:
	int ref_count;
};

#endif
