
#ifndef header_backbuffer_dx7
#define header_backbuffer_dx7

#include "API/Display/pixel_buffer.h"
#include "Display/pixel_buffer_generic.h"
#include "display_window_dx7.h"

//: Pixel data implementation interface.
class CL_BackBuffer_DX7 : public CL_PixelBuffer_Generic
{
//!Construction:
public:
	CL_BackBuffer_DX7(CL_DisplayWindow_DX7 *window);

	~CL_BackBuffer_DX7();

//!Attributes:
public:
	CL_DisplayWindow_DX7 *get_window() { return window; }

	LPDIRECTDRAWSURFACE get_surface();

//!Operations:
public:
	//: Returns a pointer to the beginning of the pixel buffer. Pointer
	//: is only valid inside a lock/unlock session.
	virtual void *get_data();

	//: Locks the direct draw back buffer.
	virtual void perform_lock();

	//: Unlocks the direct draw back buffer.
	virtual void perform_unlock();

//!Implementation:
private:
	CL_DisplayWindow_DX7 *window;

	// Locked data pointer.
	void *data;
};

#endif
