
#include "Display/display_precomp.h"
#include "graphic_context_dx7.h"
#include "display_window_dx7.h"

/////////////////////////////////////////////////////////////////////////////
// CL_GraphicContext_DX7 construction:

CL_GraphicContext_DX7::CL_GraphicContext_DX7(CL_DisplayWindow_DX7 *window) :
	window(window)
{
}

CL_GraphicContext_DX7::~CL_GraphicContext_DX7()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_GraphicContext_DX7 attributes:

int CL_GraphicContext_DX7::get_width() const
{
	return window->get_width();
}

int CL_GraphicContext_DX7::get_height() const
{
	return window->get_height();
}

/////////////////////////////////////////////////////////////////////////////
// CL_GraphicContext_DX7 operations:

void CL_GraphicContext_DX7::draw_pixel(int x, int y, const CL_Color &color)
{
}

void CL_GraphicContext_DX7::draw_line(int x1, int y1, int x2, int y2, const CL_Color &color)
{
}

void CL_GraphicContext_DX7::draw_rect(const CL_Rect &rect, const CL_Color &color)
{
}

void CL_GraphicContext_DX7::fill_rect(const CL_Rect &rect, const CL_Color &color)
{
	LPDIRECTDRAWSURFACE back_buffer = window->get_backbuffer_surface();

	DDBLTFX ddbltfx;
	ddbltfx.dwSize=sizeof(ddbltfx);
	ddbltfx.dwFillColor = color;

	RECT dest;
	dest.left = rect.left;
	dest.top = rect.top;
	dest.right = rect.right;
	dest.bottom = rect.bottom;

	back_buffer->Blt(
		&dest,
		NULL,
		NULL,
		DDBLT_COLORFILL|DDBLT_WAIT,
		&ddbltfx);	// clear screen
}

void CL_GraphicContext_DX7::clear(const CL_Color &color)
{
	fill_rect(CL_Rect(0, 0, window->get_width(), window->get_height()), color);
}

/////////////////////////////////////////////////////////////////////////////
// CL_GraphicContext_DX7 implementation:
