
#ifndef header_graphic_context_dx7
#define header_graphic_context_dx7

#include "Display/graphic_context_generic.h"
#include "API/signals.h"

class CL_DisplayWindow_DX7;

class CL_GraphicContext_DX7 : public CL_GraphicContext_Generic
{
//!Construction:
public:
	CL_GraphicContext_DX7(CL_DisplayWindow_DX7 *window);

	virtual ~CL_GraphicContext_DX7();

//!Attributes:
public:
	//: Returns the current width of the context.
	virtual int get_width() const;

	//: Returns the current height of the context.
	virtual int get_height() const;

//!Operations:
public:
	//: Draw a pixel at (x, y) using the specified color.
	virtual void draw_pixel(int x, int y, const CL_Color &color);

	//: Draw a line from (x1, y1) to (x2, y2) using the specified color.
	virtual void draw_line(int x1, int y1, int x2, int y2, const CL_Color &color);

	//: Draw a rectangle using the specified color.
	virtual void draw_rect(const CL_Rect &rect, const CL_Color &color);

	//: Draw a filled rectangle using the specified color.
	virtual void fill_rect(const CL_Rect &rect, const CL_Color &color);

	//: Clears the whole context using the specified color.
	virtual void clear(const CL_Color &color);

//!Implementation:
private:
	//: DX7 window.
	CL_DisplayWindow_DX7 *window;
};

#endif
