
#ifndef header_surface_dx7
#define header_surface_dx7

#include "Display/surface_generic.h"
#include "Display/surface_target.h"
#include "API/Display/surface.h"
#include "API/Core/Math/size.h"

class CL_Surface_DX7 : public CL_Surface_Target
{
//!Construction:
public:
	CL_Surface_DX7(
		CL_PixelBuffer *provider,
		bool delete_provider,
		CL_Surface::Hint hint);

	virtual ~CL_Surface_DX7();

//!Attributes:
public:
	//: Returns the width.
	virtual int get_width() const;
	
	//: Returns the height.
	virtual int get_height() const;

//!Operations:
public:
	//: Draw surface on screen.
	virtual void draw(
		CL_Surface_Generic *attributes,
		int x, int y,
		CL_GraphicContext *gc);

	//: Draw surface on screen.
	virtual void draw(
		CL_Surface_Generic *attributes,
		const CL_Rect &dest,
		CL_GraphicContext *gc);

	//: Draw surface on screen.
	virtual void draw(
		CL_Surface_Generic *attributes,
		const CL_Rect &src,
		const CL_Rect &dest,
		CL_GraphicContext *gc);

//!Implementation:
private:
	CL_PixelBuffer *surface_buffer;
};

#endif
