
#include "Display/display_precomp.h"
#include "API/DX8/direct3d_window.h"
#include "display_window_dx8.h"

#define dx8_impl static_cast<CL_DisplayWindow_DX8 *>(impl)

/////////////////////////////////////////////////////////////////////////////
// CL_Direct3DWindow construction:

CL_Direct3DWindow::CL_Direct3DWindow(
	const std::string &title,
	int width,
	int height,
	bool start_fullscreen,
	bool allow_resize,
	int flipping_buffers)
: CL_DisplayWindow(new CL_DisplayWindow_DX8)
{
	dx8_impl->create_window(title, width, height, 0, start_fullscreen, allow_resize);
}

CL_Direct3DWindow::CL_Direct3DWindow(
	const std::string &title,
	int width,
	int height,
	bool allow_resize,
	D3DDEVTYPE device_type,
	DWORD behavior_flags,
	D3DPRESENT_PARAMETERS *present_parameters)
: CL_DisplayWindow(new CL_DisplayWindow_DX8)
{
	dx8_impl->create_window(title, width, height, allow_resize, device_type, behavior_flags, present_parameters);
}

CL_Direct3DWindow::~CL_Direct3DWindow()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_Direct3DWindow attributes:

LPDIRECT3D8 CL_Direct3DWindow::get_direct3d()
{
	return dx8_impl->get_direct3d();
}

IDirect3DDevice8 *CL_Direct3DWindow::get_device()
{
	return dx8_impl->get_device();
}

HWND CL_Direct3DWindow::get_wnd()
{
	return dx8_impl->get_hwnd();
}

/////////////////////////////////////////////////////////////////////////////
// CL_Direct3DWindow operations:

/////////////////////////////////////////////////////////////////////////////
// CL_Direct3DWindow implementation:
