
#ifndef header_display_window_dx8
#define header_display_window_dx8

#include "Display/Win32/display_window_win32.h"
#include <d3d8.h>

//: DirectX 8 display window
class CL_DisplayWindow_DX8 : public CL_DisplayWindow_Win32
{
//! Construction:
public:
	CL_DisplayWindow_DX8();

	virtual ~CL_DisplayWindow_DX8();

//! Attributes:
public:
	virtual CL_GraphicContext *get_gc();

	LPDIRECT3D8 get_direct3d() { return direct3d8; }

	IDirect3DDevice8 *get_device() { return device; }

//! Operations:
public:
	virtual void create_window(const CL_DisplayWindowDescription &desc);

	void create_window(
		const CL_DisplayWindowDescription &desc,
		D3DDEVTYPE device_type,
		DWORD behavior_flags,
		D3DPRESENT_PARAMETERS *present_parameters);

	virtual void destroy_window();

//! Implementation:
private:
	LPDIRECT3D8 direct3d8;

	IDirect3DDevice8 *device;
};

#endif
