
#ifndef header_dc_buffer_generic
#define header_dc_buffer_generic

#include <windows.h>
#include "API/Display/pixel_buffer.h"
#include "Display/pixel_buffer_generic.h"

class CL_DeviceContextBuffer_Generic : public CL_PixelBuffer_Generic
{
//! Construction:
public:
	//: Construct a pixelbuffer using the pixel format of the passed device context.
	CL_DeviceContextBuffer_Generic(HDC reference_dc, int width, int height);

	~CL_DeviceContextBuffer_Generic();

//! Attributes:
public:
	HDC get_dc() { return memory_dc; }

//! Operations:
public:
	//: Returns a pointer to the beginning of the pixel buffer. Pointer
	//: is only valid inside a lock/unlock session.
	virtual void *get_data();

	//: Reference counted lock function.
	virtual void perform_lock();

	//: Reference counted unlock function.
	virtual void perform_unlock();

//! Implementation:
private:
	HDC ref_dc;

	HDC memory_dc;

	BITMAPINFO bitmap_info;

	HBITMAP bitmap, orig_bitmap;

	unsigned char *data;

	bool first_lock;
};

#endif
