
#include "Display/display_precomp.h"
#include "input_device_win32keyboard.h"

/////////////////////////////////////////////////////////////////////////////
// CL_InputDevice_Win32Keyboard construction:

CL_InputDevice_Win32Keyboard::CL_InputDevice_Win32Keyboard(HWND hwnd)
{
	type = CL_InputDevice::keyboard;
}

CL_InputDevice_Win32Keyboard::~CL_InputDevice_Win32Keyboard()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputDevice_Win32Keyboard attributes:

bool CL_InputDevice_Win32Keyboard::get_keycode(int keycode) const
{
	return GetKeyState(keycode) & 0xfe;
}

std::string CL_InputDevice_Win32Keyboard::get_key_name(int virtual_key) const
{
	char name[1024];
	UINT scancode = MapVirtualKey(virtual_key, 0);
	int length = GetKeyNameText(scancode << 16, name, 1024);
	return std::string(name, length);
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputDevice_Win32Keyboard operations:

/////////////////////////////////////////////////////////////////////////////
// CL_InputDevice_Win32Keyboard implementation:
