
#ifndef header_input_device_win32mouse
#define header_input_device_win32mouse

#include "../input_device_generic.h"

class CL_InputDevice_Win32Mouse : public CL_InputDevice_Generic
{
//! Construction:
public:
	CL_InputDevice_Win32Mouse(HWND hwnd);

	virtual ~CL_InputDevice_Win32Mouse();

//! Attributes:
public:
	//: Returns the x position of the device.
	virtual int get_x() const;

	//: Returns the y position of the device.
	virtual int get_y() const;

	//: Returns true if the passed key code is down for this device.
	virtual bool get_keycode(int keycode) const;

	//: Key name for specified identifier (A, B, C, Space, Enter, Backspace).
	virtual std::string get_key_name(int id) const;

//! Operations:
public:
	//: Sets the position of the device.
	virtual void set_position(int x, int y);

//! Implementation:
private:
	void on_key_down(const CL_InputEvent &event);

	void on_key_up(const CL_InputEvent &event);

	bool key_states[32];
	
	HWND hwnd;

	CL_SlotContainer slots;
};

#endif
