
#ifndef header_input_device_x11keyboard
#define header_input_device_x11keyboard

#include "../input_device_generic.h"
#include "API/signals.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>

class CL_DisplayWindow_OpenGL;

class CL_InputDevice_X11Keyboard : public CL_InputDevice_Generic
{
//!Construction:
public:
	CL_InputDevice_X11Keyboard(CL_DisplayWindow_OpenGL *owner);

	virtual ~CL_InputDevice_X11Keyboard();

//!Attributes:
public:

//!Operations:
public:
	//: Key name for specified identifier (A, B, C, Space, Enter, Backspace).
	std::string get_key_name(int id) const;
  
	//: Returns true if the passed key code is down for this device.
	bool get_keycode(int keycode) const;

//!Implementation:
private:
	void on_xevent(XEvent &event);
	
	CL_Slot slot_xevent;

	CL_DisplayWindow_OpenGL *owner;

};

#endif
