
#ifndef header_canvas_generic
#define header_canvas_generic

#include "API/Display/canvas.h"

class CL_Canvas_Generic
{
//! Construction:
public:
	CL_Canvas_Generic();

	virtual ~CL_Canvas_Generic();

//! Attributes:
public:
	//: Returns the pixel buffer of the canvas.
	virtual CL_PixelBuffer &get_pixelbuffer()=0;

	//: Returns the graphic context of the canvas.
	virtual CL_GraphicContext *get_gc()=0;

//! Operations:
public:
	//: Draw canvas onto graphic context.
	virtual void draw(int x, int y, CL_GraphicContext *gc)=0;

	void add_ref();

	void release_ref();

//! Implementation:
private:
	int ref_count;
};

#endif
