
#ifndef header_display_target
#define header_display_target

#include "API/Display/canvas.h"
#include "API/Display/surface.h"

class CL_Canvas_Generic;
class CL_DisplayWindow_Generic;
class CL_Surface_Target;
class CL_Texture_Generic;

class CL_DisplayTarget
{
//! Construction:
public:
	CL_DisplayTarget();

	~CL_DisplayTarget();

//! Attributes:
public:
	static CL_DisplayTarget *current;

//! Operations:
public:
	virtual CL_Canvas_Generic *create_canvas(
		const CL_Size &size,
		CL_Canvas::Format format,
		bool use_colorkey,
		unsigned int colorkey)=0;

	virtual CL_Canvas_Generic *create_canvas(
		CL_PixelBuffer *provider,
		bool delete_provider,
		CL_Canvas::Format format,
		bool use_colorkey,
		unsigned int colorkey)=0;

	virtual CL_DisplayWindow_Generic *create_window()=0;

	virtual CL_Surface_Target *create_surface(
		CL_PixelBuffer *provider,
		bool delete_provider,
		CL_Surface::Hint hint)=0;

	virtual CL_Texture_Generic *create_texture(
		CL_PixelBuffer *provider,
		bool delete_provider)=0;

//! Implementation:
private:
};

#endif
