
#include "Display/display_precomp.h"
#include "display_window_generic.h"
#include "API/Display/input_device.h"
#include "API/Display/input_context.h"

/////////////////////////////////////////////////////////////////////////////
// CL_DisplayWindow_Generic construction:

CL_DisplayWindow_Generic::CL_DisplayWindow_Generic() : cursor_visible(true), ref_count(0)
{
}

CL_DisplayWindow_Generic::~CL_DisplayWindow_Generic()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_DisplayWindow_Generic attributes:

CL_DisplayWindow *CL_DisplayWindow_Generic::current = 0;

/////////////////////////////////////////////////////////////////////////////
// CL_DisplayWindow_Generic operations:

void CL_DisplayWindow_Generic::add_ref()
{
	ref_count++;
}

void CL_DisplayWindow_Generic::release_ref()
{
	ref_count--;
	if (ref_count == 0) delete this;
}

void CL_DisplayWindow_Generic::do_flip()
{
	CL_InputDevice &mouse = get_ic()->get_mouse();
	if (!cursor.is_null()) cursor.draw(mouse.get_x(), mouse.get_y(), get_gc());
	flip();
}

void CL_DisplayWindow_Generic::set_cursor(const CL_Sprite &sprite)
{
	cursor = sprite;
	cursor_changed();
	if (cursor_visible)
	{
		if (!cursor.is_null()) hide_system_cursor();
		else show_system_cursor();
	}
}

void CL_DisplayWindow_Generic::show_cursor()
{
	if (cursor.is_null()) show_system_cursor();
	cursor_visible = true;
}

void CL_DisplayWindow_Generic::hide_cursor()
{
	if (cursor.is_null()) hide_system_cursor();
	cursor_visible = false;
}

/////////////////////////////////////////////////////////////////////////////
// CL_DisplayWindow_Generic implementation:
