
#ifndef header_input_buffer_generic
#define header_input_buffer_generic

#include <queue>
#include "API/Display/input_event.h"
#include "API/signals.h"

class CL_InputBuffer_Generic
{
//! Construction:
public:
	CL_InputBuffer_Generic() : ref_count(0) { return; }

//! Attributes:
public:
	std::queue<CL_InputEvent> buffer;

	CL_SlotContainer slots;

//! Operations:
public:
	void add_ref() { ref_count++; }

	void release_ref() { ref_count--; if (ref_count == 0) delete this; }

	void on_key_down(const CL_InputEvent &key) { buffer.push(key); }

	void on_key_up(const CL_InputEvent &key) { buffer.push(key); }

//! Implementation:
private:
	int ref_count;
};

#endif
