
#include "Display/display_precomp.h"
#include "API/Display/input_button.h"
#include "input_button_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_InputButton construction:

CL_InputButton::CL_InputButton()
: impl(new CL_InputButton_Generic)
{
}

CL_InputButton::CL_InputButton(const CL_InputButton &copy)
: impl(new CL_InputButton_Generic)
{
	// TODO:
}

CL_InputButton::~CL_InputButton()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputButton attributes:

int CL_InputButton::peek_pressed() const
{
	return impl->presses;
}

CL_InputEvent CL_InputButton::peek_key() const
{
	// TODO:
	return CL_InputEvent();
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputButton operations:

CL_InputButton &CL_InputButton::operator =(const CL_InputButton &copy)
{
	// TODO:
	return *this;
}

void CL_InputButton::bind(const CL_KeyBinding &key)
{
	impl->bind(key);
}

void CL_InputButton::unbind(const CL_KeyBinding &key)
{
	impl->unbind(key);
}

void CL_InputButton::unbind_all()
{
	impl->bindings.clear();
}

const std::list<CL_KeyBinding> &CL_InputButton::get_bindings() const
{
	return impl->bindings;
}

int CL_InputButton::pop_pressed()
{
	int presses = impl->presses;
	impl->presses = 0;
	return presses;
}

CL_InputEvent CL_InputButton::pop_key()
{
	int presses = impl->presses;
	impl->presses = 0;
	return CL_InputEvent();
}

void CL_InputButton::clear()
{
	impl->presses = 0;
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputButton implementation:
