
#ifndef header_inputbutton_generic
#define header_inputbutton_generic

#include "API/Display/input_event.h"
#include "API/Display/key_binding.h"
#include "API/signals.h"

#include <list>

class CL_InputButton_Generic
{
//! Construction:
public:
	CL_InputButton_Generic() { return; }

//! Attributes:
public:
	int presses;
	std::list<CL_KeyBinding> bindings;

//! Operations:
public:
	void bind(const CL_KeyBinding &key);
	void unbind(const CL_KeyBinding &key);

//! Implementation:
private:
	CL_SlotContainer slots;

	void on_input_down(const CL_InputEvent &key);
	void on_input_up(const CL_InputEvent &key);
};

#endif
