
#include "Display/display_precomp.h"
#include "API/Display/input_context.h"
#include "input_context_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_InputContext Construction:

CL_InputContext::CL_InputContext(
	int num_keyboards,
	int num_mice,
	int num_joysticks)
: impl(0)
{
	impl = new CL_InputContext_Generic(num_keyboards, num_mice, num_joysticks);
	impl->add_ref();
}

CL_InputContext::~CL_InputContext()
{
	if (impl) impl->release_ref();
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputContext Attributes:

int CL_InputContext::get_keyboard_count() const
{
	return impl->keyboards.size();
}

int CL_InputContext::get_mouse_count() const
{
	return impl->mice.size();
}

int CL_InputContext::get_joystick_count() const
{
	return impl->joysticks.size();
}

CL_InputDevice &CL_InputContext::get_keyboard(int keyboard)
{
	return impl->keyboards[keyboard];
}

CL_InputDevice &CL_InputContext::get_mouse(int mouse)
{
	return impl->mice[mouse];
}

CL_InputDevice &CL_InputContext::get_joystick(int joystick)
{
	return impl->joysticks[joystick];
}

/////////////////////////////////////////////////////////////////////////////
// CL_InputContext operations:

/////////////////////////////////////////////////////////////////////////////
// CL_InputContext implementation:

