
#ifndef header_input_context_generic
#define header_input_context_generic

#include <vector>
#include "API/Display/input_device.h"

class CL_InputEvent;

//: Input events interface.
class CL_InputContext_Generic
{
//! Construction:
public:
	CL_InputContext_Generic(
		int num_keyboards,
		int num_mice,
		int num_joysticks);

	~CL_InputContext_Generic();

//! Attributes:
public:
	std::vector<CL_InputDevice> keyboards;

	std::vector<CL_InputDevice> mice;

	std::vector<CL_InputDevice> joysticks;

//! Operations:
public:
	void add_ref();

	void release_ref();

//! Implementation:
private:
	int ref_count;
};

#endif
