
#include "Display/display_precomp.h"
#include "API/Display/joystick.h"
#include "API/Display/display.h"
#include "API/Display/display_window.h"
#include "API/Display/input_context.h"
#include "API/Display/input_device.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Joystick construction:

/////////////////////////////////////////////////////////////////////////////
// CL_Joystick attributes:

#define get_ic() CL_Display::get_current_window()->get_ic()

int CL_Joystick::get_device_count()
{
	return get_ic()->get_keyboard_count();
}

CL_InputDevice &CL_Joystick::get_device(int joystick)
{
	return get_ic()->get_joystick(joystick);
}

bool CL_Joystick::get_keycode(int keycode, int joystick)
{
	return get_ic()->get_joystick(joystick).get_keycode(keycode);
}

std::string CL_Joystick::get_key_name(int id)
{
	return get_ic()->get_joystick().get_key_name(id);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Joystick operations:

/////////////////////////////////////////////////////////////////////////////
// CL_Joystick signals:

CL_Signal_v1<const CL_InputEvent &> &CL_Joystick::sig_key_down(int joystick)
{
	return get_ic()->get_joystick(joystick).sig_key_down();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Joystick::sig_key_up(int joystick)
{
	return get_ic()->get_joystick(joystick).sig_key_up();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Joystick::sig_key_dblclk(int joystick)
{
	return get_ic()->get_joystick(joystick).sig_key_dblclk();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Joystick::sig_move(int joystick)
{
	return get_ic()->get_joystick(joystick).sig_move();
}

/////////////////////////////////////////////////////////////////////////////
// CL_Joystick implementation:
