
#include "Display/display_precomp.h"
#include "API/Display/keyboard.h"
#include "API/Display/display.h"
#include "API/Display/display_window.h"
#include "API/Display/input_context.h"
#include "API/Display/input_device.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Keyboard construction:

/////////////////////////////////////////////////////////////////////////////
// CL_Keyboard attributes:

#define get_ic() CL_Display::get_current_window()->get_ic()

int CL_Keyboard::get_device_count()
{
	return get_ic()->get_keyboard_count();
}

CL_InputDevice &CL_Keyboard::get_device(int keyboard)
{
	return get_ic()->get_keyboard(keyboard);
}
	
bool CL_Keyboard::get_keycode(int keycode, int keyboard)
{
	return get_ic()->get_keyboard(keyboard).get_keycode(keycode);
}

std::string CL_Keyboard::get_key_name(int id)
{
	return get_ic()->get_keyboard().get_key_name(id);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Keyboard operations:

/////////////////////////////////////////////////////////////////////////////
// CL_Keyboard signals:

CL_Signal_v1<const CL_InputEvent &> &CL_Keyboard::sig_key_down(int keyboard)
{
	return get_ic()->get_keyboard(keyboard).sig_key_down();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Keyboard::sig_key_up(int keyboard)
{
	return get_ic()->get_keyboard(keyboard).sig_key_up();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Keyboard::sig_key_dblclk(int keyboard)
{
	return get_ic()->get_keyboard(keyboard).sig_key_dblclk();
}

/////////////////////////////////////////////////////////////////////////////
// CL_Input implementation:
