
#include "Display/display_precomp.h"
#include "API/Display/mouse.h"
#include "API/Display/display.h"
#include "API/Display/display_window.h"
#include "API/Display/input_context.h"
#include "API/Display/input_device.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Mouse construction:

/////////////////////////////////////////////////////////////////////////////
// CL_Mouse attributes:

#define get_ic() CL_Display::get_current_window()->get_ic()

int CL_Mouse::get_device_count()
{
	return get_ic()->get_mouse_count();
}

CL_InputDevice &CL_Mouse::get_device(int mouse)
{
	return get_ic()->get_mouse(mouse);
}

int CL_Mouse::get_x(int mouse)
{
	return get_ic()->get_mouse(mouse).get_x();
}
	
int CL_Mouse::get_y(int mouse)
{
	return get_ic()->get_mouse(mouse).get_y();
}
	
bool CL_Mouse::get_keycode(int keycode, int mouse)
{
	return get_ic()->get_mouse(mouse).get_keycode(keycode);
}

std::string CL_Mouse::get_key_name(int id)
{
	return get_ic()->get_mouse().get_key_name(id);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Mouse operations:

void CL_Mouse::set_position(int x, int y, int mouse)
{
	get_ic()->get_mouse(mouse).set_position(x, y);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Mouse signals:

CL_Signal_v1<const CL_InputEvent &> &CL_Mouse::sig_key_down(int mouse)
{
	return get_ic()->get_mouse(mouse).sig_key_down();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Mouse::sig_key_up(int mouse)
{
	return get_ic()->get_mouse(mouse).sig_key_up();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Mouse::sig_key_dblclk(int mouse)
{
	return get_ic()->get_mouse(mouse).sig_key_dblclk();
}

CL_Signal_v1<const CL_InputEvent &> &CL_Mouse::sig_move(int mouse)
{
	return get_ic()->get_mouse(mouse).sig_move();
}

/////////////////////////////////////////////////////////////////////////////
// CL_Mouse implementation:
