
#include "Display/display_precomp.h"
#include "pixel_buffer_memory.h"

/////////////////////////////////////////////////////////////////////////////
// CL_PixelBuffer_Memory construction:

CL_PixelBuffer_Memory::CL_PixelBuffer_Memory(
	int width, int height, int pitch, const CL_PixelFormat &format, void *data_ptr)
{
	CL_PixelBuffer_Generic::width = width;
	CL_PixelBuffer_Generic::height = height;
	CL_PixelBuffer_Generic::pitch = pitch;
	CL_PixelBuffer_Generic::format = format;

	if (data_ptr)
	{
		delete_data = false;
		data = (unsigned char *) data_ptr;
	}
	else
	{
		delete_data = true;
		data = new unsigned char[pitch*height];
	}
}

CL_PixelBuffer_Memory::CL_PixelBuffer_Memory(
	int width, int height, int pitch, const CL_PixelFormat &format, const CL_Palette &palette, void *data_ptr)
{
	CL_PixelBuffer_Generic::width = width;
	CL_PixelBuffer_Generic::height = height;
	CL_PixelBuffer_Generic::pitch = pitch;
	CL_PixelBuffer_Generic::format = format;
	CL_PixelBuffer_Generic::palette = palette;

	if (data_ptr)
	{
		delete_data = false;
		data = (unsigned char *) data_ptr;
	}
	else
	{
		delete_data = true;
		data = new unsigned char[pitch*height];
	}
}

CL_PixelBuffer_Memory::~CL_PixelBuffer_Memory()
{
	if (delete_data) delete[] data;
}

/////////////////////////////////////////////////////////////////////////////
// CL_PixelBuffer_Memory operations:

void *CL_PixelBuffer_Memory::get_data()
{
	return data;
}

void CL_PixelBuffer_Memory::perform_lock()
{
}

void CL_PixelBuffer_Memory::perform_unlock()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_PixelBuffer_Memory implementation:

