
#ifndef header_pixel_buffer_memory
#define header_pixel_buffer_memory

#include "API/Display/pixel_buffer.h"
#include "pixel_buffer_generic.h"

//: Memory pixel data implementation.
class CL_PixelBuffer_Memory : public CL_PixelBuffer_Generic
{
//! Construction:
public:
	CL_PixelBuffer_Memory(int width, int height, int pitch, const CL_PixelFormat &format, void *data = 0);

	CL_PixelBuffer_Memory(int width, int height, int pitch, const CL_PixelFormat &format, const CL_Palette &palette, void *data = 0);

	virtual ~CL_PixelBuffer_Memory();

//! Operations:
public:
	//: Returns a pointer to the beginning of the pixel buffer. Pointer
	//: is only valid inside a lock/unlock session.
	virtual void *get_data();

	//: Reference counted lock function. Allocate pixel buffer in this function. 
	virtual void perform_lock();

	//: Reference counted unlock function. Free pixel buffer in this function.
	virtual void perform_unlock();

//! Implementation:
private:
	unsigned char *data;

	bool delete_data;
};

#endif
