
#include "Display/display_precomp.h"
#include "resourcedata_texture.h"
#include "API/Core/Resources/resourceoptions.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/Display/Providers/provider_factory.h"

//////////////////////////////////////////////////////////////////////////////
// CL_ResourceData_Texture construction:

CL_ResourceData_Texture::CL_ResourceData_Texture(CL_Resource &resource)
: CL_ResourceData(resource)
{
	slots.connect(resource.sig_load_file(), this, &CL_ResourceData_Texture::on_load_file);
	slots.connect(resource.sig_load_datafile(), this, &CL_ResourceData_Texture::on_load_datafile);
	slots.connect(resource.sig_save_datafile(), this, &CL_ResourceData_Texture::on_save_datafile);
	slots.connect(resource.sig_unload(), this, &CL_ResourceData_Texture::on_unload);

	resource.attach_data("texture", this);
}

CL_ResourceData_Texture::~CL_ResourceData_Texture()
{
}

//////////////////////////////////////////////////////////////////////////////
// CL_ResourceData_Texture attributes:


//////////////////////////////////////////////////////////////////////////////
// CL_ResourceData_Texture implementation:

void CL_ResourceData_Texture::on_load_file()
{
	CL_Resource resource = get_resource();
	CL_ResourceOptions &options = resource.get_options();

	CL_PixelBuffer *image = CL_ProviderFactory::load(
		resource.get_location(),
		"",
		resource.get_manager().get_resource_provider());

	texture = CL_Texture(image, true);
}
	
void CL_ResourceData_Texture::on_load_datafile(CL_InputSourceProvider *)
{
}
	
void CL_ResourceData_Texture::on_save_datafile(CL_OutputSourceProvider *)
{
}
	
void CL_ResourceData_Texture::on_unload()
{
	texture = CL_Texture();
}
