
#ifndef header_sprite_generic
#define header_sprite_generic

#include "API/Display/surface.h"
#include "API/Display/blend_func.h"
#include "API/Core/Math/origin.h"
#include "API/Display/sprite.h"
#include "API/Core/Math/point.h"
#include "API/Core/Math/rect.h"

#include <vector>

class CL_Sprite_Generic
{
//! Construction:
public:
	CL_Sprite_Generic();

	virtual ~CL_Sprite_Generic();

public:
	class SpriteFrame
	{
	public:
		//: Image data
		CL_Surface surface;

		//: Position in surface that frame is located at.
		CL_Rect position;

		//: Draw offset 
		CL_Point offset;

		//: Animation delay
		float delay;
	};

//! Attributes:
public:
	SpriteFrame *get_frame(unsigned int index);
	
	float angle;
	float base_angle;
	float scale_x, scale_y;

	float red,green,blue,alpha;

	CL_BlendFunc blend_src;
	CL_BlendFunc blend_dest;

	CL_Point translation_hotspot;
	CL_Point rotation_hotspot;
	CL_Origin translation_origin;
	CL_Origin rotation_origin;

	short current_frame;
	short delta_frame;

	float update_time;
	float last_time;

	int id;
	
	bool finished;
	bool play_loop;
	bool play_backward;
	bool play_pingpong;
	CL_Sprite::ShowOnFinish show_on_finish;

	std::vector<SpriteFrame> frames;

//! Operations:
public:
	//: Copy assignment operator.
	CL_Sprite_Generic &operator =(const CL_Sprite_Generic &copy);

	float calc_time_elapsed();

//! Signals:
public:
	CL_Signal_v0 sig_animation_finished;
};

#endif
