
#ifndef header_sprite_packer_generic
#define header_sprite_packer_generic

#include "API/Core/Math/size.h"
#include "API/Core/Math/rect.h"
#include "API/Display/sprite_description.h"
#include "API/Display/surface.h"
#include "API/Display/sprite_packer.h"

// Stuff to improve:
// - Sort the textures after size before inserting - might do wonders

class CL_SpritePacker_Generic
{
//! Construction:
public:
	CL_SpritePacker_Generic(const CL_SpriteDescription &description);

	class Node
	{
	public:
		Node();
		Node(const CL_Rect &rect);
		~Node();

		Node *insert(CL_SpriteDescription::FramePair image);
		void clear();
		
		Node *child[2];
		CL_Rect rect;
	    
	    CL_PixelBuffer *image;
	    CL_Rect image_rect;
	};

//! Attributes:
public:
	const CL_SpriteDescription &description;

	std::vector<CL_Size> texture_sizes;
	std::list<CL_SpritePacker::TexturePair> packed_frames;
};

#endif

