
#ifndef header_surface_generic
#define header_surface_generic

#include "API/Core/Math/origin.h"
#include "API/Display/blend_func.h"
#include "API/Core/Math/point.h"

class CL_Surface_Target;

class CL_Surface_Generic
{
//! Construction:
public:
	CL_Surface_Generic(CL_Surface_Target *target);

	virtual ~CL_Surface_Generic();

//! Attributes:
public:
	//: Shared data object between surfaces.
	CL_Surface_Target *target;

	float angle;

	float scale_x, scale_y;

	float red, green, blue, alpha;

	CL_BlendFunc blend_src;
	
	CL_BlendFunc blend_dest;

	CL_Pointf translation_hotspot;

	CL_Pointf rotation_hotspot;

	CL_Origin translation_origin;

	CL_Origin rotation_origin;

//! Operations:
public:
	//: Copy assignment operator.
	CL_Surface_Generic &operator =(const CL_Surface_Generic &copy);

//! Implementation:
private:
};

#endif
