
#ifndef header_surface_target
#define header_surface_target

class CL_PixelBuffer;
class CL_Surface_Generic;
class CL_GraphicContext;
class CL_Rect;

class CL_Surface_Target
{
//! Construction:
public:
	CL_Surface_Target();

	virtual ~CL_Surface_Target();

//! Attributes:
public:
	//: Returns the width.
	virtual int get_width() const=0;
	
	//: Returns the height.
	virtual int get_height() const=0;

//! Operations:
public:
	//: Draw surface on screen.
	virtual void draw(
		CL_Surface_Generic *attributes,
		int x, int y,
		CL_GraphicContext *gc)=0;

	//: Draw surface on screen.
	virtual void draw(
		CL_Surface_Generic *attributes,
		const CL_Rect &dest,
		CL_GraphicContext *gc)=0;

	//: Draw surface on screen.
	virtual void draw(
		CL_Surface_Generic *attributes,
		const CL_Rect &src,
		const CL_Rect &dest,
		CL_GraphicContext *gc)=0;

	void add_ref();

	void release_ref();

//! Implementation:
private:
	int ref_count;
};

#endif
