
#include "Display/display_precomp.h"
#include "API/Display/text_styler.h"
#include "API/Display/graphic_context.h"
#include "API/Display/glyph_buffer.h"

using namespace std;

CL_TextStyler::CL_TextStyler() :
	col_r(1.0f), col_g(1.0f), col_b(1.0f), col_a(1.0f),
	scale_x(1.0f), scale_y(1.0f),
	rot_angle(0.0f), rot_origin(origin_center),
	rot_x(0), rot_y(0), trans_origin(origin_top_left),
	trans_x(0), trans_y(0), blend_src(blend_src_alpha),
	blend_dest(blend_one_minus_src_alpha) {}

CL_TextStyler::PrintInfo CL_TextStyler::test_draw(
	const CL_Rect &dest,
	const string::const_iterator& start,
	const string::const_iterator& end,
	const string& delim) const
{
	return CL_TextStyler::PrintInfo();
}

CL_TextStyler::PrintInfo CL_TextStyler::draw(
	const CL_Rect& dest,
	const string::const_iterator& start,
	const string::const_iterator& end,
	const string& delim,
	CL_GraphicContext *context)
{
	return CL_TextStyler::PrintInfo();
}
	
CL_TextStyler::PrintInfo CL_TextStyler::draw_to_gb(
	const CL_Rect &dest,
	const string::const_iterator &start,
	const string::const_iterator &end,
	const CL_GlyphBuffer& gb,
	const string &delim) const
{
	return CL_TextStyler::PrintInfo();
}

void CL_TextStyler::set_angle(float angle)
{
	while(angle >= 360.0f)
		angle -= 360.0f;
	while(angle < 0.0f)
		angle += 360.0f;
	
	rot_angle = angle;
}
