
#ifndef header_texture_generic
#define header_texture_generic

#include "API/Core/Math/size.h"
class CL_GraphicContext;

class CL_Texture_Generic
{
//! Construction:
public:
	CL_Texture_Generic() : ref_count(0) { return; }

	virtual ~CL_Texture_Generic() { return; }

//! Attributes:
public:
	CL_Size screen_size;
	CL_Size texture_size;
	
//! Operations:
public:
	virtual void bind(CL_GraphicContext *gc) = 0;

	void add_ref() { ref_count++; }
	
	void release_ref() { ref_count--; if (ref_count == 0) delete this; }
	
//! Implementation:
private:
	int ref_count;
};

#endif
