
#include "Display/display_precomp.h"
#include "opengl_target.h"
#include "canvas_opengl.h"
#ifdef WIN32
#include "WGL/display_window_opengl.h"
#else
#include "GLX/display_window_opengl.h"
#endif
#include "texture_opengl.h"
#include "surface_opengl.h"

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget construction:


/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget attributes:


/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget operations:

CL_Canvas_Generic *CL_OpenGLTarget::create_canvas(
	const CL_Size &size,
	CL_Canvas::Format format,
	bool use_colorkey,
	unsigned int colorkey)
{
	return new CL_Canvas_OpenGL(size, format, use_colorkey, colorkey);
}

CL_Canvas_Generic *CL_OpenGLTarget::create_canvas(
	CL_PixelBuffer *provider,
	bool delete_provider,
	CL_Canvas::Format format,
	bool use_colorkey,
	unsigned int colorkey)
{
	return new CL_Canvas_OpenGL(provider, delete_provider, format, use_colorkey, colorkey);
}

CL_DisplayWindow_Generic *CL_OpenGLTarget::create_window()
{
	return new CL_DisplayWindow_OpenGL;
}

CL_Surface_Target *CL_OpenGLTarget::create_surface(
	CL_PixelBuffer *provider,
	bool delete_provider,
	CL_Surface::Hint hint)
{
	return new CL_Surface_OpenGL(provider, delete_provider, hint);
}

CL_Texture_Generic *CL_OpenGLTarget::create_texture(
	CL_PixelBuffer *provider,
	bool delete_provider)
{
	return new CL_Texture_OpenGL(provider, delete_provider);
}

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget implementation:
