
#ifndef header_pixelbuffer_opengl_frame
#define header_pixelbuffer_opengl_frame

#include "API/Display/graphic_context.h"
#include "Display/pixel_buffer_generic.h"
#include <GL/gl.h>

//: Pixel data access to a frame buffer.
class CL_PixelBuffer_OpenGL_Frame : public CL_PixelBuffer_Generic
{
//! Construction:
public:
	CL_PixelBuffer_OpenGL_Frame(GLenum frame, CL_GraphicContext &gc);

	~CL_PixelBuffer_OpenGL_Frame();

//! Operations:
public:
	virtual void *get_data();

	virtual void perform_lock();

	virtual void perform_unlock();

//! Implementation:
private:
	GLenum frame;

	CL_GraphicContext gc;

	char *data;
};

#endif
