
#ifndef header_pixelbuffer_opengl_texture
#define header_pixelbuffer_opengl_texture

#include "API/Display/graphic_context.h"
#include "Display/pixel_buffer_generic.h"
#include <GL/gl.h>

//: Pixel data access of a texture.
class CL_PixelBuffer_OpenGL_Texture : public CL_PixelBuffer_Generic
{
//! Construction:
public:
	CL_PixelBuffer_OpenGL_Texture(
		int offset_x,
		int offset_y,
		int width,
		int height,
		GLuint handle,
		CL_GraphicContext *gc);

	~CL_PixelBuffer_OpenGL_Texture();

//! Operations:
public:
	virtual void *get_data();

	virtual void perform_lock();

	virtual void perform_unlock();

//! Implementation:
private:
	int offset_x, offset_y;

	GLuint handle;

	CL_GraphicContext *gc;

	GLint texture_width, texture_height;

	char *data;
};

#endif
