*
	$Id: inputdialog.cpp,v 1.3 2003/02/25 21:08:37 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"
#include <string>
#include "../API/GUI/inputdialog.h"
#include "../API/GUI/component_options.h"
#include "../API/GUI/stylemanager.h"
#include "../API/GUI/gui_manager.h"
#include "inputdialog_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_InputDialog::CL_InputDialog(
	const std::string &title,
	const std::string &button1,
	const std::string &button2,
	const std::string &button3,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Window(parent, style), impl(0)
{
	impl = new CL_InputDialog_Generic(this, title, button1, button2, button3);
}

CL_InputDialog::~CL_InputDialog()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

CL_InputBox * CL_InputDialog::add_input_box(const std::string &label,
	const std::string &default_value, int inputbox_width)
{
	return impl->add_input_box(label, default_value, inputbox_width);
}
