/*
	$Id: menunode.cpp,v 1.4 2002/04/06 11:10:55 grumbel Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"

#include "API/GUI/component.h"
#include "API/GUI/menunode.h"
#include "menunode_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_MenuNode::CL_MenuNode(CL_PopupMenu *submenu)
{
	impl = new CL_MenuNode_Generic(this, submenu);
}

CL_MenuNode::~CL_MenuNode()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// Attributes:

bool CL_MenuNode::has_submenu() const
{
	return (impl->submenu != NULL);
}

void *CL_MenuNode::get_userdata() const
{
	return impl->userdata;
}

CL_Component *CL_MenuNode::get_component() const
{
	return impl->component;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

void CL_MenuNode::set_component(CL_Component *component, bool delete_component)
{
	if(impl->component)
	{
		// TODO: Disconnect the signal:
		// impl->slots.connect(new_component->sig_mouse_up(), impl, &CL_MenuNode_Generic::on_child_click);

		if(impl->delete_component)
			delete impl->component;
	}

	impl->component = component;
	impl->delete_component = delete_component;

	impl->slots.connect(component->sig_mouse_up(), impl, &CL_MenuNode_Generic::on_child_click);
}

void CL_MenuNode::set_userdata(void *data)
{
	impl->userdata = data;
}
