/*
	$Id: menunode_generic.cpp,v 1.8 2002/08/01 10:39:24 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"

#include "API/GUI/component.h"
#include "API/GUI/popupmenu.h"
#include "menunode_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_MenuNode_Generic::CL_MenuNode_Generic(CL_MenuNode *self, CL_PopupMenu *submenu)
{
	menunode = self;
	
	this->submenu = submenu;

	component = NULL;
	delete_component = false;

	userdata = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_MenuNode_Generic::on_child_click(const CL_InputEvent &key)
{
	if(submenu)
	{
		CL_Component *root = component->get_root_parent();

		// Position new popup
		CL_Rect pos = component->get_screen_rect();
		if(pos.right + submenu->get_width() > root->get_width()) // Will it be outside view?
			pos.right -= (component->get_width() + submenu->get_width());  // If so, move it to the left side
		submenu->set_position(pos.right, pos.top);

		// Pop it up
		submenu->popup(root);
	}
}
