/*
	$Id: messagebox.cpp,v 1.17 2003/02/25 21:08:37 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"
#include <string>
#include "../API/GUI/messagebox.h"
#include "../API/GUI/component_options.h"
#include "../API/GUI/stylemanager.h"
#include "../API/GUI/gui_manager.h"
#include "messagebox_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_MessageBox::CL_MessageBox(
	const std::string &title,
	const std::string &text,
	const std::string &button1,
	const std::string &button2,
	const std::string &button3,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Window(parent, style), impl(0)
{
	impl = new CL_MessageBox_Generic(this, title, text, button1, button2, button3);
}

CL_MessageBox::~CL_MessageBox()
{
	delete impl;
}

int CL_MessageBox::info(
	const std::string &text,
	CL_Component *parent,
	CL_StyleManager *style)
{
	CL_MessageBox message("Information", text, "Ok", "", "", parent, style);
	message.run();
	return message.get_result_button();
}

int CL_MessageBox::info(
	const std::string &title,
	const std::string &text,
	CL_Component *parent,
	CL_StyleManager *style)
{
	CL_MessageBox message(title, text, "Ok", "", "", parent, style);
	message.run();
	return message.get_result_button();
}

int CL_MessageBox::info(
	const std::string &title,
	const std::string &text,
	const std::string &button1,
	const std::string &button2,
	const std::string &button3,
	CL_Component *parent,
	CL_StyleManager *style)
{
	CL_MessageBox message(title, text, button1, button2, button3, parent, style);
	message.run();
	return message.get_result_button();
}

/////////////////////////////////////////////////////////////////////////////
// Attributes:

int CL_MessageBox::get_result_button() const
{
	return impl->result_button;
}
