/*
	$Id: popupmenu_generic.cpp,v 1.24 2003/01/19 19:19:12 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"
#include "popupmenu_generic.h"
#include "API/GUI/component_options.h"
#include "API/GUI/gui_manager.h"
#include <iostream>

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_PopupMenu_Generic::CL_PopupMenu_Generic(CL_PopupMenu *self)
: popupmenu(self)
{
	// Create client area (which is the main popupmenu)
	CL_Component *client_area = new CL_Component(popupmenu);
	popupmenu->set_client_area(client_area);
	
	slot_resize = popupmenu->sig_resize().connect(
		this, &CL_PopupMenu_Generic::on_resize);

	on_resize(popupmenu->get_width(), popupmenu->get_height());
}

CL_PopupMenu_Generic::~CL_PopupMenu_Generic()
{
	delete popupmenu->get_client_area();
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

void CL_PopupMenu_Generic::popup(CL_Component *parent)
{
	slot_mouse_down = parent->sig_mouse_down().connect(
		this, &CL_PopupMenu_Generic::on_mouse_down);
	slot_lost_focus = popupmenu->get_client_area()->sig_lost_focus().connect(
		this, &CL_PopupMenu_Generic::on_lost_focus);

	// Alt.1: Run popupmenu as a modal component
//	popupmenu->run(parent);

	// Alt.2: Run popupmenu as a captured component
//	parent->add_child(popupmenu);
//	popupmenu->capture_mouse();
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_PopupMenu_Generic::on_mouse_down(const CL_InputEvent &key)
{
//	std::cout << "mouse" << std::endl;
	
/*	CL_Rect pos = popupmenu->get_screen_rect();
	if(key.x < pos.x1 || key.y < pos.y1 || key.x > pos.x2 || key.y > pos.y2)
	{
		sig_cancelled();
		popupmenu->close();
	}	
*/
}

void CL_PopupMenu_Generic::on_resize(int old_width, int old_height)
{
	int width = popupmenu->get_width();
	int height = popupmenu->get_height();

	CL_Rect rect(4, 4, 4 + width - 8, 4 + height - 8);
	popupmenu->get_client_area()->set_position(rect);
}

void CL_PopupMenu_Generic::on_lost_focus()
{
//	std::cout << "focus" << std::endl;
}
