/*
	$Id: window.cpp,v 1.24 2003/02/23 14:50:45 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"
#include "API/GUI/window.h"
#include "API/GUI/component_options.h"
#include "API/GUI/stylemanager.h"
#include "API/GUI/gui_manager.h"
#include "window_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction

CL_Window::CL_Window(
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(parent->get_gui_manager(), style), impl(0)
{
	impl = new CL_Window_Generic(this, std::string());
	get_style_manager()->connect_styles("window", this);
	find_preferred_size();
}

CL_Window::CL_Window(
	const CL_Rect &pos,
	const std::string &title,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(pos, parent->get_gui_manager(), style), impl(0)
{
	impl = new CL_Window_Generic(this, title);
	get_style_manager()->connect_styles("window", this);
}

CL_Window::CL_Window(
	const CL_Rect &pos,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(pos, parent->get_gui_manager(), style), impl(0)
{
	impl = new CL_Window_Generic(this, std::string());
	get_style_manager()->connect_styles("window", this);
}

CL_Window::CL_Window(
	const std::string &title,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(parent->get_gui_manager(), style), impl(0)
{
	impl = new CL_Window_Generic(this, title);
	get_style_manager()->connect_styles("window", this);
	find_preferred_size();
}

CL_Window::~CL_Window()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// Attributes:

const std::string &CL_Window::get_title() const
{
	return impl->title;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

void CL_Window::set_title(const std::string &text)
{
	impl->title = text;
}

/////////////////////////////////////////////////////////////////////////////
// Signals:
