/*
	$Id: window_generic.cpp,v 1.22 2003/02/15 12:36:34 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "precomp.h"
#include "window_generic.h"
#include "API/GUI/component_options.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_Window_Generic::CL_Window_Generic(
	CL_Window *window,
	const std::string &title)
: title(title), window(window)
{
	CL_Component *client_area = new CL_Component(window);
	window->set_client_area(client_area);
	
	slot_set_options = window->sig_set_options().connect(this, &CL_Window_Generic::on_set_options);
}

CL_Window_Generic::~CL_Window_Generic()
{
	delete window->get_client_area();
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_Window_Generic::on_set_options(const CL_ComponentOptions &options)
{
	if(options.exists("title"))
		title = options.get_value("title");
}
