/*
	$Id: frame_boring.cpp,v 1.2 2003/02/18 15:31:58 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "API/Display/surface.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUIStyleBoring/frame_boring.h"
#include "API/GUIStyleBoring/stylemanager_boring.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_Frame_Boring::CL_Frame_Boring(
	CL_Frame *_frame,
	CL_StyleManager_Boring *style) 
:
	CL_ComponentStyle(_frame),
	frame(_frame),
	style(style)
{
	resources = style->get_resources();

	slot_paint = frame->sig_paint().connect(
		this, &CL_Frame_Boring::on_paint);
}

CL_Frame_Boring::~CL_Frame_Boring()
{
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_Frame_Boring::on_paint()
{
	int width = frame->get_width();
	int height = frame->get_height();

	style->draw_box(0, 0, width, height, GUICOLOR_DARK_SHADE, GUICOLOR_BRIGHT_SHADE);

	if(frame->is_fill_enabled())
		style->fill_rect(1, 1, width - 1, height -1, GUICOLOR_MEDIUM_SHADE);
}
