/*
	$Id: progressbar_boring.cpp,v 1.2 2003/02/18 15:31:58 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "API/Display/surface.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUIStyleBoring/progressbar_boring.h"
#include "API/GUIStyleBoring/stylemanager_boring.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_ProgressBar_Boring::CL_ProgressBar_Boring(
	CL_ProgressBar *progressbar,
	CL_StyleManager_Boring *style)
:
	CL_ComponentStyle(progressbar),
	progressbar(progressbar),
	style(style)
{
	slot_paint = progressbar->sig_paint().connect(
		this, &CL_ProgressBar_Boring::on_paint);
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_ProgressBar_Boring::on_paint()
{
	int width = progressbar->get_width();
	int height = progressbar->get_height();
	float percent = progressbar->get_percentage();

	// Outline
	style->draw_rect(0, 0, width, height, GUICOLOR_DARK_OUTLINE);

	// Shade box
	style->draw_box(1, 1, width - 1 , height - 1, GUICOLOR_DARK_SHADE, GUICOLOR_BRIGHT_SHADE);

	// Fill
	int length = (int) ((width - 4) * percent);

	style->fill_rect(2, 2, 2 + length, height - 2, GUICOLOR_PROGRESSBAR_FILLED);
	style->fill_rect(2 + length, 2, width - 2, height - 2, GUICOLOR_PROGRESSBAR);
}
