/*
	$Id: treeitem_boring.cpp,v 1.1 2003/02/18 14:25:10 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "API/Display/font.h"
#include "API/GUIStyleBoring/treeitem_boring.h"
#include "API/GUIStyleBoring/stylemanager_boring.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_TreeItem_Boring::CL_TreeItem_Boring(
	CL_TreeItem *treeview_item,
	CL_StyleManager_Boring *style)
:
	CL_ComponentStyle(treeview_item),
	item(treeview_item),
	style(style)
{
	resources = style->get_resources();
	font = new CL_Font("TreeViewItem/font", resources);
		
	slot_paint = item->sig_paint().connect(
		this, &CL_TreeItem_Boring::on_paint);
	slot_get_preferred_size = item->sig_get_preferred_size().connect(
		this, &CL_TreeItem_Boring::on_get_preferred_size);
}

CL_TreeItem_Boring::~CL_TreeItem_Boring()
{
	delete font;
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_TreeItem_Boring::on_get_preferred_size(CL_Point &size)
{
	size.x = font->get_width(item->get_text()) + 8;
	size.y = font->get_height(item->get_text());
}

void CL_TreeItem_Boring::on_paint()
{
	int height = item->get_height();
	int width = item->get_width();
	
	if(item->has_mouse_over())
		style->fill_rect(0, 0, width, height, GUICOLOR_SELECTION);
	else
		style->fill_rect(0, 0, width, height, GUICOLOR_WINDOW_NORMAL);

	int font_height = font->get_height(item->get_text());
	font->draw(4, (height - font_height) / 2, item->get_text());
}
