/*
	$Id: label_silver.cpp,v 1.1 2003/02/18 14:25:10 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "API/Display/font.h"
#include "API/Display/display.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUI/component_style.h"
#include "API/GUIStyleSilver/label_silver.h"
#include "API/GUIStyleSilver/stylemanager_silver.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_Label_Silver::CL_Label_Silver(
	CL_Label *label,
	CL_StyleManager_Silver *style)
:
	CL_ComponentStyle(label),
	label(label)
{
	resources = style->get_resources();
	
	font = new CL_Font("Label/font", resources);
	
	slot_paint = label->sig_paint().connect(
		this, &CL_Label_Silver::on_paint);
	slot_get_preferred_size = label->sig_get_preferred_size().connect(
		this, &CL_Label_Silver::on_get_preferred_size);
}

CL_Label_Silver::~CL_Label_Silver()
{
	delete font;
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_Label_Silver::on_get_preferred_size(CL_Point &size)
{
	size.x = font->get_width(label->get_text());
	size.y = font->get_height(label->get_text());
}

void CL_Label_Silver::on_paint()
{
	const char *text = label->get_text().c_str();

	CL_Point pos = calc_origin(label->get_alignment(), CL_Size(label->get_width() / 2, label->get_height()));
	
	font->draw(pos.x, pos.y, text);
}
