/*
	$Id: progressbar_silver.cpp,v 1.4 2003/02/23 20:32:09 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#include "API/Display/display.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUIStyleSilver/progressbar_silver.h"
#include "API/GUIStyleSilver/stylemanager_silver.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_ProgressBar_Silver::CL_ProgressBar_Silver(
	CL_ProgressBar *progressbar,
	CL_StyleManager_Silver *style)
:
	CL_ComponentStyle(progressbar),
	progressbar(progressbar),
	style(style)
{
	slot_paint = progressbar->sig_paint().connect(
		this, &CL_ProgressBar_Silver::on_paint);
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_ProgressBar_Silver::on_paint()
{
	int width = progressbar->get_width();
	int height = progressbar->get_height();
	float percent = progressbar->get_percentage();

	// Outline
	CL_Display::draw_rect(CL_Rect(0, 0, width, height), CL_Color(128, 142, 159));

	// Fill
	int length = (int) ((width - 4) * percent);

	CL_Display::fill_rect(
		CL_Rect(2, 2, 2 + length, height - 2),
		CL_Gradient(
			CL_Color::white,
			CL_Color(254, 207, 147),
			CL_Color::white,
			CL_Color(254, 207, 147)));
			
	CL_Display::fill_rect(CL_Rect(2 + length, 2, width - 2, height - 2), CL_Color::white);

	// TODO: Write percentage in text
//	font->draw(...);
}
