/*
	$Id: event_trigger_socket.h,v 1.3 2002/11/23 01:19:33 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_event_trigger_socket
#define header_event_trigger_socket

#include "API/signals.h"
#include "API/Core/System/event_trigger.h"
#include <map>

class CL_SocketSelect;
class CL_Socket_Generic;

class CL_EventTrigger_Socket : public CL_EventTrigger
{
public:
	enum Type
	{
		read,
		write,
		exception
	};

//! Construction:
public:
	CL_EventTrigger_Socket(CL_Socket_Generic *sock, Type type);

	~CL_EventTrigger_Socket();

//! Attributes:
public:
	CL_Socket_Generic *get_socket() const { return sock; }

	Type get_type() const { return type; }

	static CL_SocketSelect *socket_select;

//! Operations:
public:
	void start_listen();

//! Implementation:
private:

	CL_Socket_Generic *sock;
	Type type;
};

#endif
