/*
	$Id: directsound.h,v 1.4 2002/07/17 14:55:30 mbn Exp $
	
	ClanSound, sound mixing library written for ClanLib.
	Copyright (c)1998 Magnus Norddahl / ClanSoft.
*/

#ifndef header_directsound
#define header_directsound

#include <dsound.h>

class CL_CSOutput
{
public:
	CL_CSOutput();
	~CL_CSOutput();

	//: Called when we have no samples to play - and wants to tell the soundcard
	//: about this possible event.
	void silence();

	//: Returns true if all fragments are filled with data.
	bool is_full();

	//: Returns the buffer size used by device (returned as num [stereo] samples).
	int get_frag_size() const { return frag_size; }

	//: Writes a fragment to the soundcard.
	void write_fragment(short *data);

	//: Waits until output source isn't full anymore.
	void wait();

private:
	LPDIRECTSOUND directsound;
	LPDIRECTSOUNDBUFFER soundbuffer;
	int frag_size, buffer_size, bytes_per_sample;
	HANDLE sleep_event;
	LPDIRECTSOUNDNOTIFY notify;
};

#endif
