/*
	$Id: mixer.h,v 1.3 2002/07/17 14:55:30 mbn Exp $
	
	ClanSound, sound mixing library written for ClanLib.
	Copyright (c)1998 Magnus Norddahl / ClanSoft.
*/

#ifndef header_mixer
#define header_mixer

#ifdef WIN32
#include "directsound.h"
#else
#include "oss.h"
#endif

#include <list>

class CL_CardPlayback_ClanSound;

class CL_CSMixer
{
public:
	CL_CSMixer();
	~CL_CSMixer();

	//: Mix one fragment.
	void mix(class CL_Mutex *mutex);
	
	//: Waits until output source isn't full anymore.
	void wait();
	
	//: Adds a playback session to the mixer.
	void add(CL_CardPlayback_ClanSound *playback);

	//: Removes a playback session from the mixer.
	void remove(CL_CardPlayback_ClanSound *playback);

private:
	std::list<CL_CardPlayback_ClanSound*> playbacks;
	CL_CSOutput output;

	short *mix_buffer;
	int *mix_buffer2;
	int mix_buffer_size;
};

#endif
