#include <ClanLib/core.h>
#include <ClanLib/display.h>
#include <ClanLib/network.h>
#include <ClanLib/application.h>

#include <iostream>

class NetChannelDemo : public CL_ClanApplication
{
public:

	NetChannelDemo() {}
	~NetChannelDemo() {}

	virtual int main(int argc, char **argv)
	{
		try
		{
			CL_SetupCore::init();
			CL_SetupNetwork::init();
		
			run_server();
			run_client();
		}
		catch(...)
		{
			std::cout << "Fatal Error" << std::endl;
		}

		return 0;
	}

	bool run_server() 
	{
		host = new CL_NetSession("Hello");
		host->start_listen("9999");
		host->sig_computer_connected().connect(this, &NetChannelDemo::on_connect);
		return true;
	}
	
	bool run_client()
	{
		client = new CL_NetSession("Hello");
		client->connect(CL_IPAddress("localhost", "9999"));
		return false;
	}

	void on_connect(CL_NetComputer &computer)
	{
		std::cout << "A computer connected from " << computer.get_address().get_address() << std::endl;;
	}

	void on_disconnect(CL_NetComputer &computer)
	{
		std::cout << "Computer " << computer.get_address().get_address() << "disconnected" << std::endl;
	}

private:

	CL_NetSession *client;
	CL_NetSession *host;
} app;
