/*
	$Id: client.cpp,v 1.2 2003/02/24 05:37:59 plasmoid Exp $
	
	Program to test how well sockets work in ClanLib.
	
	Author: Mark Robinson Feb 2003
*/

#include <ClanLib/core.h>
#include <ClanLib/application.h>
#include <ClanLib/network.h>

class SockClient : public CL_ClanApplication
{
	CL_IPAddress *client_ip;
	CL_Socket *client_socket;
	
public:
	int main(int argv, char**)
	{
	
		CL_SetupCore::init();
		CL_SetupNetwork::init();
		
		std::string message = (std::string)"ping\n";
		
		client_ip = new CL_IPAddress("localhost", "9000");
		client_socket = new CL_Socket(CL_Socket::tcp);
		
		client_socket->connect(*client_ip);
		client_socket->send(message);
		
		for(int i = 0; i < 5; i++)
		{
			CL_System::keep_alive();
			client_socket->send(message);
			CL_System::sleep(1000);
		}
		
		delete client_ip;
		delete client_socket;
		
		return 0;
	
	
	}


} app;
